
#include <iostream>
#include <format>
#include <bitset>

int main() {
    double d = 0.1;
    int64_t n;
    static_assert(sizeof(n) == sizeof(d));
    // n = *reinterpret_cast<std::int64_t*>(&d); // Undefined behavior
    n = std::bit_cast<int64_t>(d);          // OK
    std::cout << d << "\n";
    std::cout << n << "\n";
    std::cout << "0x" << std::hex << n << "\n";
    std::cout << std::format("{:b}", n) << "\n";
    std::cout << std::bitset<64>(n) << "\n";
}
