
#include <iostream>
#include <vector>
#include <bitset>
using namespace std;

//vector<bool> vb{32,true};//warning: narrowing conversion of ‘32’ from ‘int’ to ‘bool’ inside { }
vector<bool> vb(32,true);       // O.K. = 32 true values
bitset<32>   bs{999};

int main() {
    cout << "vb.size()=" << vb.size() << endl;
    cout << "vb={" << endl;
    for(int i=vb.size()-1; i>=0; --i)
        cout << vb[i] << (i?",":"\n");
    cout << "}" << endl;

    cout << "bs.size()=" << bs.size() << endl;
    cout << "bs.count()=" << bs.count() << endl;
    cout << "bs={" << endl;
    for(int i=bs.size()-1; i>=0; --i)
        cout << bs[i] << (i?",":"\n");
    cout << "}" << endl;
    cout << bs << endl;
    bs.set(20);
    cout << bs << endl;
    bs.flip(24);
    cout << bs << endl;

    bs = ~bs;
    cout << bs << endl;
    bs |= ~0xFFUL;
    cout << bs << endl;
    bs &= 0xFFFFUL;
    cout << bs << endl;
    bs ^= 1;
    cout << bs << endl;
    bitset<32> bs2{"xxxx___xxx"+1,8,'_','x'};
    cout << bs2 << endl;
    bs2 <<= 10;
    cout << bs2 << endl;
    bs2.flip();
    cout << bs2 << endl;
    bs2.set();
    cout << bs2 << endl;
    bs2.reset();
    cout << bs2 << endl;
    bs2 = bs;
    cout << bs2 << endl;
    cout << boolalpha;
    cout << "(bs2==bs): " << (bs2 == bs) << endl;
}
