
// test

#include <string>
#include <iostream>

int f1(std::string s) {
    int count=0;
    for(auto x: s)
        count++;
    return count;
}

int f2(std::string_view s) {
    int count=0;
    for(auto x: s)
        count++;
    return count;
}

int main() {
    const char * test = "test string";
    std::cout << f1(test) << '\n';
    std::cout << f2(test) << '\n';
    using namespace std::string_view_literals;
    std::cout << f2("test string"sv) << '\n';
    if(std::string_view(test).starts_with("te")) std::cout << "starts with 'te'\n";
}

